//#include <xc.h>		// If using XC8
#include <avr/io.h>	// If using AVR-GCC
#include <util/delay.h>

#include "sreg.h"

uint8_t g_sregValue;

void SregInit()
{
	// Set up port direction
	// PIC -> 0: output, 1: input
	/*
	CBI(SREG_DIR, SREG_DATA);
	CBI(SREG_DIR, SREG_CLK);
#if SREG_74595
	CBI(SREG_DIR, SREG_LE);
	SBI(SREG_PORT, SREG_LE);
#endif
	*/
	// AVR -> 1: output, 0: input
	
	SBI(SREG_DIR, SREG_DATA);
	SBI(SREG_DIR, SREG_CLK);
#if SREG_74595
	SBI(SREG_DIR, SREG_LE);
	CBI(SREG_PORT, SREG_LE);
#endif
	
}

void SregSend(uint8_t d)
{
	g_sregValue = d;
	uint8_t i;
	for(i=0; i<8; i++){
		if(d & 0x80){
			SBI(SREG_PORT, SREG_DATA);
		}else{
			CBI(SREG_PORT, SREG_DATA);
		}
		CBI(SREG_PORT, SREG_CLK);
		asm("nop");
		SBI(SREG_PORT, SREG_CLK);
		d = d << 1;
	}

#if SREG_74595
	SBI(SREG_PORT, SREG_LE);
	asm("nop");
	CBI(SREG_PORT, SREG_LE);
#endif

}

uint8_t SregGetState(){
	return g_sregValue;
}

