#ifndef _SREG_H_
#define _SREG_H_

#include <stdint.h>

#ifndef SBI
#define SBI(io, bit) (io |= (1 << bit))
#endif
#ifndef CBI
#define CBI(io, bit) (io &= ~(1 << bit))
#endif

#define SREG_74164	0
#define SREG_74595	1

// PIC-like IO definition
#define SREG_DIR	DDRD
#define SREG_PORT	PORTD
#define SREG_DATA	PB1
#define SREG_CLK	PD4
#if SREG_74595
#define SREG_LE		PD0
#endif

void SregInit();
void SregSend(uint8_t d);
void SregSetBit(uint8_t d);
void SregClearBit(uint8_t d);
uint8_t SregGetState();

#endif
