// AVR HV Programmer
// Eleken 2018
// rev_c1815@yahoo.co.jp
// http://eleken.y-lab.org/

// Partly (constant definition) pulled from:
// http://star.gmobb.jp/koji/cgi/wiki.cgi?page=AVR%A5%D1%A5%E9%A5%EC%A5%EB%A5%E9%A5%A4%A5%BF%A1%BC%A4%CE%C0%BD%BA%EE



#ifndef _WRITER_H_
#define _WRITER_H_

#define LPT_DAT		0x01
#define LPT_STA		0x02
#define LPT_CTL		0x03
#define USB_DAT		0x04
#define HVS_DAT		0x05
#define USB_POW		0x06
#define SET_BYTE	0x07
#define RCV_BYTE	0x08
#define STB_PAGEL	0x09
#define STB_WR		0x0A
#define RFL_PP		0x0B
#define REE_PP		0x0C
#define RFL_HVS		0x0D
#define REE_HVS		0x0E
#define WFL_PP		0x0F
#define WEE_PP		0x10
#define WFL_HVS		0x11
#define WEE_HVS		0x12

#define	POWER_OFF	0x00
#define	HVP_ON		0x01
#define	HVS_ON		0x02
#define	P_NORMAL	0x00
#define	P_QUICK		0x01

#define FL_PG_RES	0x04
#define FL_PG_END	0x02
#define FL_LARGE	0x01

/* Device programming commands */

#define C_NOP		0x00
#define C_ERASE		0x80
#define C_WR_PRG	0x10
#define C_RD_PRG	0x02
#define C_WR_EEP	0x11
#define C_RD_EEP	0x03
#define C_WR_FB		0x40
#define C_RD_FB		0x04
#define C_WR_LB		0x20
#define C_RD_SIG	0x08

#define	I_LDCMD		0x4C
#define	I_LDAL		0x0C
#define	I_LDAH		0x1C
#define	I_LDDL		0x2C
#define	I_LDDH		0x3C
#define	I_PSTL1		0x6D
#define	I_PSTL2		0x6C
#define	I_PSTH1		0x7D
#define	I_PSTH2		0x7C
#define	I_RDLL1		0x68
#define	I_RDLL2		0x6C
#define	I_RDLH1		0x78
#define	I_RDLH2		0x7C
#define	I_RDHL1		0x6A
#define	I_RDHL2		0x6E
#define	I_RDHH1		0x7A
#define	I_RDHH2		0x7E
#define	I_WRLL1		0x64
#define	I_WRLL2		0x6C
#define	I_WRLH1		0x74
#define	I_WRLH2		0x7C
#define	I_WRHL1		0x66
#define	I_WRHL2		0x6E

#define XA_0		0x01
#define	XA_1		0x02
#define	BS_1		0x04
#define BS_2		0x08


uint8_t WriterFunc(const uint8_t* rcvBuf, uint8_t* sendBuf);


#endif
